# -*- coding: utf-8 -*-
# Generated by Django 1.11.17 on 2021-09-23 15:21
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('customers', '0063_auto_20210922_1620'),
        ('providers', '0008_auto_20210922_1620'),
    ]
    sql = """
CREATE OR REPLACE VIEW public.providers_financialrecord AS 
 SELECT 'I'::text || providers_invoice.id::text AS record_id,
    providers_invoice.paid,
    providers_invoice.due_date AS ts,
    providers_invoice.total AS original_charge,
    NULL::integer AS original_credit,
    CASE
            WHEN providers_invoice.tasa IS NULL THEN providers_invoice.total
            WHEN providers_invoice.tasa IS NOT NULL THEN sum(providers_invoice.total*providers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
    NULL::integer AS credit,
    providers_invoice.tasa,
    ((providers_invoice.comment::text || ' (Folio: '::text) || providers_invoice.folio::text) || ')'::text AS comment,
    providers_invoice.provider_id
   FROM providers_invoice
    GROUP BY providers_invoice.id
UNION
 SELECT 'P'::text || providers_payment.id::text AS record_id,
    true AS paid,
    providers_payment.paid_on AS ts,
    NULL::integer AS original_charge,
    providers_payment.amount AS original_credit,
    NULL::integer AS charge,
    CASE
            WHEN providers_payment.tasa IS NULL THEN providers_payment.amount
            WHEN providers_payment.tasa IS NOT NULL THEN sum(providers_payment.amount*providers_payment.tasa)
            ELSE NULL::integer
        END AS credit,
    providers_payment.tasa,
    providers_payment.comment,
    providers_payment.provider_id
   FROM providers_payment
    GROUP BY providers_payment.id
  ORDER BY 3 DESC
    """
    balance_sql = """
    CREATE OR REPLACE VIEW public.providers_balance AS 
    SELECT c.id,
    c.id AS provider_id,
    COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance
   FROM providers_provider c
     LEFT JOIN providers_financialrecord fr ON c.id = fr.provider_id
  GROUP BY c.id
    """
    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS providers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS providers_financialrecord"),
        migrations.RemoveField(
            model_name='historicalpayment',
            name='currency',
        ),
        migrations.RemoveField(
            model_name='payment',
            name='currency',
        ),
        migrations.AddField(
            model_name='historicalpayment',
            name='bank_account',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.BankAccount'),
        ),
        migrations.AddField(
            model_name='payment',
            name='bank_account',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='payment_bankaccount', to='customers.BankAccount'),
        ),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql)
    ]

